//23 is the lower y limit, 8 is the higher limit
//USE OLD BOOTLOADER
#include <OLED_I2C.h>
#include <Adafruit_Sensor.h>
#include <DHT.h>
#include <DHT_U.h>
#include "HX711.h"
#include <EEPROM.h>


#define DHTPIN 2 
#define DHTTYPE DHT22 

#define zero_factor 621224
#define calibration_factor 1068

OLED  myOLED(SDA, SCL);
DHT_Unified dht(DHTPIN, DHTTYPE);
HX711 scale;

extern uint8_t SmallFont[];
extern uint8_t MediumNumbers[];
extern uint8_t TinyFont[];
uint32_t delayMS;

const int slider = A1;
const int LOADCELL_DOUT_PIN = 4;
const int LOADCELL_SCK_PIN = 5;
const int ground = 6;
const int vcc = 7;
const int relay = 3;

int sliderValue = 525;
int addr = 0; //EEPROM
int firstWeight = 0; // set at bottom of program
byte value; //EEPROM
long stored_time = millis(); 
float oldHumidity;
int c,d,e,f,I,z = 2;

void setup()
{

  pinMode(ground, OUTPUT);
  pinMode(vcc, OUTPUT);
  pinMode(relay, OUTPUT);
  digitalWrite(ground, LOW);
  digitalWrite(vcc, HIGH);
  digitalWrite(relay, LOW);
  
  myOLED.begin(SSD1306_128X32);
  myOLED.setBrightness(150);

 Serial.begin(9600);

  dht.begin();
  sensor_t sensor;
  dht.temperature().getSensor(&sensor);
  dht.humidity().getSensor(&sensor);
  delayMS = sensor.min_delay / 1000;
  scale.begin(LOADCELL_DOUT_PIN, LOADCELL_SCK_PIN);
  
  Serial.println("Before setting up the scale:");
  Serial.print("read: \t\t");
  Serial.println(scale.read());      // print a raw reading from the ADC

  Serial.print("read average: \t\t");
  Serial.println(scale.read_average(20));   // print the average of 20 readings from the ADC

  Serial.print("get value: \t\t");
  Serial.println(scale.get_value(5));   // print the average of 5 readings from the ADC minus the tare weight (not set yet)

  Serial.print("get units: \t\t");
  Serial.println(scale.get_units(5), 1);  // print the average of 5 readings from the ADC minus tare weight (not set) divided
            // by the SCALE parameter (not set yet)

  scale.set_scale(calibration_factor);                      // this value is obtained by calibrating the scale with known weights; see the README for details
  scale.set_offset(zero_factor);

  Serial.println("After setting up the scale:");

  Serial.print("read: \t\t");
  Serial.println(scale.read());                 // print a raw reading from the ADC

  Serial.print("read average: \t\t");
  Serial.println(scale.read_average(20));       // print the average of 20 readings from the ADC

  Serial.print("get value: \t\t");
  Serial.println(scale.get_value(5));    // print the average of 5 readings from the ADC minus the tare weight, set with tare()

  Serial.print("get units: \t\t");
  Serial.println(scale.get_units(5), 1);        // print the average of 5 readings from the ADC minus tare weight, divided
            // by the SCALE parameter set with set_scale

  Serial.println("Readings:");

}

void loop()
{
//////////////////////TARE SETTING/////////////////////////////
 if (analogRead(slider) < 10)
  {
    myOLED.clrScr();
    myOLED.setFont(SmallFont);
    myOLED.print("TARE SET", CENTER, 17);
    myOLED.update();
    scale.tare();
    delay(2000);
    myOLED.clrScr();
    while (analogRead(slider) < 10)
    {
      myOLED.print("load weed now", CENTER, 17);
      myOLED.update();       
    }
    I = 3; //for the EEPROM tare at bottom of program
  }
  Serial.println("first weight");
  Serial.println(firstWeight);
 //////////////////////////////////////////////////////////////////
  sensors_event_t event;
 ////////////////////OLED STARTUP//////////////////////////////////
  while ( z == 2 ) {
  myOLED.setFont(SmallFont);
  myOLED.print("dry yo weed",CENTER, 23);
  myOLED.setFont(MediumNumbers);
  dht.temperature().getEvent(&event);
  myOLED.printNumF(event.temperature, 2, RIGHT, 0);
   dht.humidity().getEvent(&event);
  myOLED.printNumF(event.relative_humidity, 2, LEFT, 0);
  myOLED.update();
  delay(1000);
  myOLED.clrScr();
  myOLED.drawCircle(63,15,15);
  myOLED.drawRoundRect(3,5,125,30);
  myOLED.update();
  delay(2000);
  myOLED.clrScr();
  z = 3;
  }
/////////////////////////////////////////////////////////////// 
  dht.temperature().getEvent(&event);
  String temp = String(event.temperature, 0);
  dht.humidity().getEvent(&event);
  String humid = String(event.relative_humidity, 2);
//////////////////////MAIN SCREEN//////////////////////////////
 if (analogRead(slider) > 490)
 {
  myOLED.clrScr();
  myOLED.setFont(SmallFont);
  myOLED.print("Temp:",0,0);
  myOLED.print(temp,30,0);
  myOLED.print(humid,90,0);
  myOLED.print("%", RIGHT,0);
  myOLED.setFont(MediumNumbers);
  myOLED.printNumF(scale.get_units(10), 2, LEFT, 10);
  myOLED.update();
 }
////////////////////////////////////////////////////////////
sliderValue = analogRead(slider);
int minutes = ((millis() - stored_time)/1000)/60;

///////////////SLIDER DIVIDER///////////////////////////////
    if(sliderValue > 490 && sliderValue < 550) {
        myOLED.setFont(SmallFont);
        myOLED.print("START", RIGHT,23);
        myOLED.update();
        if ( c == 2)
        {
          stored_time = millis(); 
          c=3;
          digitalWrite(relay, LOW);
        }
        if (minutes >= 20)
        {
          if (minutes < 23)
          {
            digitalWrite(relay, HIGH); 
          } else {
                    digitalWrite(relay, LOW);
                    c = 2;
                 }
          }    
    } else { c = 2;}
    
    if(sliderValue > 570 && sliderValue < 650) {
        myOLED.setFont(SmallFont);
        myOLED.print("| HALF |", RIGHT,23);
        myOLED.update();
        if ( d == 2)
        {
          stored_time = millis(); 
          d=3;
          digitalWrite(relay, LOW);

        }
        if (minutes >= 30)
        {
          if (minutes < 33)
          {
            digitalWrite(relay, HIGH); 
          } else {
                    digitalWrite(relay, LOW);
                    d = 2;
                 }      
        }
    } else { d = 2;}

    if(sliderValue > 725 && sliderValue < 850) {
        myOLED.setFont(SmallFont);
        myOLED.print("| HOUR |", RIGHT,23);
        myOLED.update();
        if ( e == 2)
        {
          stored_time = millis(); 
          e=3; 
          digitalWrite(relay, LOW);
        }
        if (minutes >= 60)
        {
          if (minutes < 63)
          {
            digitalWrite(relay, HIGH); 
          } else {
                    digitalWrite(relay, LOW);
                    e = 2;
                 }
          
          
        }
    } else {e = 2;}

    if(sliderValue > 900 && sliderValue < 1000) {
        
        myOLED.setFont(TinyFont);
        myOLED.print("| 20% |", RIGHT,23);
        myOLED.update();
        if (f == 2)
        {
          dht.humidity().getEvent(&event);
          oldHumidity = event.relative_humidity;
          f = 3;
          digitalWrite(relay, LOW);

        }
        if ((humid.toInt() - oldHumidity) > 20)
        {
          digitalWrite(relay, HIGH);
          if (f == 3) 
          {
            stored_time = millis();
          }
          f = 4;            
        }
        if ((humid.toInt()-oldHumidity) <= 5 && f == 4)
        {
          digitalWrite(relay, LOW);
        }
        if (minutes > 10 && f == 4)
        {
          digitalWrite(relay, LOW);
        }
    } else {f = 2;}

    if(sliderValue > 1000){
        myOLED.setFont(TinyFont);
        myOLED.print("| ON |", RIGHT,23);
        myOLED.update();
        digitalWrite(relay, HIGH);
        c = 2;
        d = 2;
        e = 2;
        f = 2;
    }
Serial.print("minutes ");
Serial.println(minutes);
Serial.print("time");
Serial.println(stored_time);
Serial.print("humidity: ");
Serial.print((oldHumidity));
Serial.print("difference");
Serial.println(humid.toInt() - oldHumidity);
Serial.print("value: ");
Serial.print(value);

if (sliderValue < 450 && sliderValue > 300)
{
  myOLED.clrScr();
  myOLED.setFont(MediumNumbers);
  myOLED.printNumF(value, 2, CENTER, 15);
  myOLED.update();
}

if (sliderValue < 300 && sliderValue > 30)
{
  digitalWrite(relay, LOW);
  myOLED.clrScr();
  myOLED.setFont(SmallFont);
  myOLED.print("OFF", CENTER, 15);
  myOLED.update();
} 

////////////////////////////////////////////////////////////
value = EEPROM.read(addr);
/////////////////EEPROM////////////////////////////////////
 Serial.print(addr);
  Serial.print("\t");
  Serial.print(value, DEC);
  Serial.println();
///////////////////////////////////////////////////////////

  scale.power_down();              // put the ADC in sleep mode
  delay(500);
  scale.power_up();
  if (I == 3) 
  { 
    firstWeight = scale.get_units(20); 
    delay(100);
    EEPROM.write(addr, firstWeight);
    I = 4;
  }
  
  

  
}



  /* int y = random(0, myOLED.getDisplayHeight()-8);
  for (int i=128; i>=-(34*6); i--)
  {
  float numbered = (analogRead(slider));
    myOLED.printNumF(numbered,0, i, y);
    myOLED.update();
    delay(50);
  }*/
